﻿using System;
using System.Threading;
using System.Runtime.InteropServices;

using wclCommon;
using wclBluetooth;
using System.Text;

namespace GattClient
{
    class Program
    {
        [DllImport("Kernel32")]
        private static extern bool SetConsoleCtrlHandler(EventHandler handler, bool add);
        
        private enum CtrlType
        {
            CTRL_C_EVENT = 0,
            CTRL_BREAK_EVENT = 1,
            CTRL_CLOSE_EVENT = 2,
            CTRL_LOGOFF_EVENT = 5,
            CTRL_SHUTDOWN_EVENT = 6
        }

        private delegate bool EventHandler(CtrlType sig);

        private static bool Handler(CtrlType sig)
        {
            Console.WriteLine("Exiting system due to external CTRL-C, or process kill, or shutdown");

            FEvent.Set();

            return true;
        }

        private static ManualResetEvent FEvent;
        
        static void Main(string[] args)
        {
            // Use APC synchronization.
            wclMessageBroadcaster.SetSyncMethod(wclMessageSynchronizationKind.skApc);

            // Create termination event.
            FEvent = new ManualResetEvent(false);
            // Handle CTRL+C event.
            EventHandler aHandler = new EventHandler(Handler);
            SetConsoleCtrlHandler(aHandler, true);

            Console.WriteLine("Start working thread");
            WorkingThread Thread = new WorkingThread();

            System.Threading.Thread.Sleep(5000);

            FEvent.WaitOne();
            FEvent.Close();
            FEvent = null;

            Thread.Terminate();
        }
    }
}
